#include <afxwin.h>
#include "controller.h"



DWORD CALLBACK ControlThread(LPVOID pVoid)
{
	HANDLE events[] = 
	{
		CreateEvent(NULL, TRUE, FALSE, MINIMIZE_EVENT),
		CreateEvent(NULL, TRUE, FALSE, MAXIMIZE_EVENT),
		CreateEvent(NULL, TRUE, FALSE, RESTORE_EVENT)
	};

	UINT commands[] = 
	{
		SW_MINIMIZE,
		SW_MAXIMIZE,
		SW_SHOWNORMAL
	};

	while (1)
	{
		DWORD waitRes = WaitForMultipleObjects(COUNTOF(events), events, FALSE, INFINITE);
		ShowWindow(*(AfxGetApp()->m_pMainWnd), commands[waitRes - WAIT_OBJECT_0]);
	}

	return 0;
}

class CMyApp: public CWinApp
{
	BOOL InitInstance()
	{
		CFrameWnd * pfr = new CFrameWnd;
		m_pMainWnd = pfr;
		pfr->Create(NULL, TEXT("Overlapped Window"));
		pfr->ShowWindow(SW_SHOWNORMAL);
		pfr->UpdateWindow();

		DWORD threadId;
		::CloseHandle(::CreateThread(NULL, 0, ControlThread, NULL, 0, &threadId));

		return TRUE;
	}
};

CMyApp theApp;